;4 led with delays

RCC_AHB1ENR 	EQU 0x40023830
GPIOD_MODER 	EQU 0x40020C00	;also base address for GPIOD
GPIOD_EN		EQU	1<<3
	
MODER15			EQU	1<<30
MODER14			EQU	1<<28
MODER13			EQU	1<<26
MODER12			EQU	1<<24
	
LED_BLUE		EQU	1<<15
LED_RED			EQU	1<<14
LED_ORANGE		EQU	1<<13
LED_GREEN		EQU 1<<12
	
GPIOD_OPDATAREG EQU 0x40020C14
	
DELAY			EQU	0x000F
ONESEC			EQU	5333333
HSEC			EQU	266667
FSEC			EQU	106667


				AREA |.text|, READONLY, CODE, ALIGN=2
				THUMB
				EXPORT __main
__main
		BL GPIOD_init
		
GPIOD_init
		LDR R0, =RCC_AHB1ENR
		LDR R1, [R0]
		ORR R1, R1, #GPIOD_EN
		STR R1, [R0]
		
		LDR R0, =GPIOD_MODER
		LDR R1, =(MODER15|MODER14|MODER13|MODER12)
		STR R1, [R0]
		
		MOV R1, #0
		LDR R2, =GPIOD_OPDATAREG
		
Blink
		MOVW R1, #LED_BLUE
		STR R1, [R2]
		LDR R3, =ONESEC
		BL Delay
		
		MOVW R1, #LED_RED
		STR R1, [R2]
		LDR R3, =ONESEC
		BL Delay
		
		MOVW R1, #LED_ORANGE
		STR R1, [R2]
		LDR R3, =ONESEC
		BL Delay
		
		MOVW R1, #LED_GREEN
		STR R1, [R2]
		LDR R3, =ONESEC
		BL Delay
		B Blink
		
Delay
		SUBS R3, R3, #1
		BNE Delay
		BX LR

		ALIGN
		END
		